/*
 *  File Name       : RSPF0_spu_api.h
 *  Function        : SPU OPEN SOUND I/F
 *  Release Version : Ver 1.00
 *  Release Date    : 2011/11/30
 *
 *  Copyright (C) 2011 Renesas Electronics Corporation
 *
 *  This program is free software;you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by Free
 *  Softwere Foundation; either version 2 of License, or (at your option) any
 *  later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program;
 *  If not, write to the Free Software Foundation, Inc., 51 Franklin St,
 *  Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef __RSPF0_SPU_API_H__
#define __RSPF0_SPU_API_H__

#include "RSPF0_prefix.h"

#include "RSPF0_spu_driver.h"
#include "RSPF0_spu_api_common.h"




#include "../include/RSPF0_API_S0.h"

/* Translate symbols for Prefix *************************************/
#define SPUAPI_ADDRESS_MODE_32BIT (RSPF0_ADDRESS_MODE_32BIT)
#define SPUAPI_ADDRESS_MODE_29BIT (RSPF0_ADDRESS_MODE_29BIT)
#define SPUAPI_NO_RESPONSE        (RSPF0_SPUAPI_NO_RESPONSE)
#define SPUAPI_WAIT_RESPONSE      (RSPF0_SPUAPI_WAIT_RESPONSE)
typedef RSPF0_sSPUBuffer   sSPUBuffer;
typedef RSPF0_sSPUDataPort sSPUDataPort;
typedef RSPF0_sSPUFmsiPort sSPUFmsiPort;
typedef RSPF0_sSPUSound    sSPUSound;
typedef RSPF0_Func         SPUAPI_Func;
/********************************************************************/

#define API_DATA_MAX_SIZE         (16)


extern long SPUAPI_Init(unsigned long dsp_id);

extern long SPUAPI_Open(unsigned long dsp_id,
			SPUAPI_Func *func,
			const unsigned long *data[3],
			const unsigned long size[3],
			unsigned long capacity[3],
			unsigned long address_mode
			);

extern long SPUAPI_Close(unsigned long dsp_id);

extern long SPUAPI_SendApi(unsigned long dsp_id,
				unsigned long api,
				unsigned long *data,
				unsigned long size,
				unsigned long sync_id
				);

extern void SPUAPI_Interrupt(unsigned long dsp_id);

extern long SPUAPI_RegisterApiReceiveHandler(unsigned long dsp_id,
		unsigned long class_id, void (*func)(unsigned long dsp_id,
		unsigned long api_id, unsigned long *data, unsigned long size));

extern unsigned long SPUAPI_DmaAddress(unsigned long addr);

extern long SPUAPI_CheckDmaParam(unsigned long start_addr, unsigned long word,
							unsigned long tr_mode);

#endif /* __RSPF0_SPU_API_H__ */

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("SPU OPEN SOUND I/F Ver 1.0");
MODULE_AUTHOR("Renesas Electronics");
