/*
 *  File Name       : RSPF0_spu_api_fmsiport.h
 *  Function        : SPU OPEN SOUND I/F
 *  Release Version : Ver 1.00
 *  Release Date    : 2011/11/30
 *
 *  Copyright (C) 2011 Renesas Electronics Corporation
 *
 *  This program is free software;you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by Free
 *  Softwere Foundation; either version 2 of License, or (at your option) any
 *  later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program;
 *  If not, write to the Free Software Foundation, Inc., 51 Franklin St,
 *  Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef __RSPF0_SPU_API_FMSIPORT_H__
#define __RSPF0_SPU_API_FMSIPORT_H__

enum {
	SPUFSIPORT_A_OUT = 0,
	SPUFSIPORT_A_IN,
	SPUFSIPORT_B_OUT,
	SPUFSIPORT_B_IN,
	SPUFSIPORT_MAX,
};

enum {
	SPUFMSIPORT_S_OUT = 0,
	SPUFMSIPORT_S_IN,
	SPUFMSIPORT_P_OUT,
	SPUFMSIPORT_P_IN,
	SPUFMSIPORT_MAX,
};

enum {
	SPUAPI_FMSIPORT_BITSELECT_FSI = 0,
	SPUAPI_FMSIPORT_BITSELECT_FMSI,
	SPUAPI_FMSIPORT_BITSELECT_FSI2,
	SPUAPI_FMSIPORT_BITSELECT_MAX,
};

enum {
	SPUAPI_FMSIPORT_THRESHOLD_MODE_HALF = 0,
	SPUAPI_FMSIPORT_THRESHOLD_MODE_SAMPLE,
	SPUAPI_FMSIPORT_THRESHOLD_MODE_MAX,
};

#if 0 /* Move to RSPF0_API.h */
typedef struct {
	unsigned long dsp_id;
	unsigned long port_id;
} sSPUFmsiPort;
#endif

typedef struct {
	unsigned long ch;
	unsigned long stereo_mono;
	unsigned long threshold_mode;
	unsigned long threshold_sample;
	unsigned long output_start_threshold;
} sSPUFmsiPortParam;

typedef void (*tSPUFmsiPortErrorCallBack)
		(sSPUFmsiPort *port, unsigned long info, unsigned long flush);

extern long SPUFmsiPort_Init(unsigned long dsp_id);
extern long SPUFmsiPort_Allocate(unsigned long dsp_id, unsigned long io_addr,
	unsigned long isr, unsigned long *fmsi_id, unsigned long bit_select);
extern long SPUFmsiPort_Create(unsigned long dsp_num, unsigned long fmsi_id,
				unsigned long port_id, sSPUFmsiPort *port);
extern long SPUFmsiPort_Delete(sSPUFmsiPort *port);
extern long SPUFmsiPort_SetCallBack(sSPUFmsiPort *port,
						tSPUFmsiPortErrorCallBack cb);
extern long SPUFmsiPort_SetParam(sSPUFmsiPort *port, sSPUBuffer *buffer,
				sSPUFmsiPortParam *param, unsigned long sync);
extern long SPUFmsiPort_Enable(sSPUFmsiPort *port, unsigned long sync);
extern long SPUFmsiPort_Disable(sSPUFmsiPort *port, unsigned long sync);
extern long SPUFmsiPort_Flush(sSPUFmsiPort *port, unsigned long sync);
extern long SPUFmsiPort_ResetError(sSPUFmsiPort *port, unsigned long sync);
extern long SPUFmsiPort_ClearSampleCount(sSPUFmsiPort *port,
							unsigned long sync);
extern long SPUFmsiPort_GetSampleCount(sSPUFmsiPort *port,
							unsigned long *count);

#endif /* __RSPF0_SPU_API_FMSIPORT_H__ */

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("SPU OPEN SOUND I/F Ver 1.0");
MODULE_AUTHOR("Renesas Electronics");
