/*
 *  File Name       : RSPF0_spu_api_soundv2.h
 *  Function        : SPU OPEN SOUND I/F
 *  Release Version : Ver 1.00
 *  Release Date    : 2011/11/30
 *
 *  Copyright (C) 2011 Renesas Electronics Corporation
 *
 *  This program is free software;you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by Free
 *  Softwere Foundation; either version 2 of License, or (at your option) any
 *  later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program;
 *  If not, write to the Free Software Foundation, Inc., 51 Franklin St,
 *  Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef __RSPF0_SPU_API_SOUND_H__
#define __RSPF0_SPU_API_SOUND_H__

#include "RSPF0_spu_api.h"

/* Structure of Sound Parameter for sw setting */
typedef struct {
	unsigned long fir_mode;
} sSoundParam;
/* Memory */
enum{
	FIR_NONE  = 0,
	FIR_EXIST = 1
};
/* Input channel for SOUND Comp */
enum{
	SOUND_MONO   = 0,
	SOUND_STEREO = 1
};
/* SRC */
enum{
	FIR_OFF = 0,
	FIR_SRC = 2
};

extern long SPUSound_Init(unsigned long dsp_id);
extern long SPUSound_Create(unsigned long dsp_id, sSPUSound *obj,
							unsigned long fir_mem);
extern long SPUSound_Delete(sSPUSound *obj);
extern long SPUSound_SetParam(sSPUSound *obj, sSPUBuffer *buf_in,
		sSPUBuffer *buf_out, unsigned long channel, sSoundParam *param,
				 unsigned long proc_size, unsigned long sync);
extern long SPUSound_Enable(sSPUSound *obj, unsigned long sync);
extern long SPUSound_Disable(sSPUSound *obj, unsigned long sync);
extern long SPUSound_SetSRC(sSPUSound *obj, unsigned long ov,
							unsigned long sync);
extern long SPUSound_Clear(sSPUSound *obj, unsigned long sync);
extern long SPUSound_GetProcessedSize(sSPUSound *obj,
		unsigned long *processed_size, unsigned long clear_flag);
#endif /* __RSPF0_SPU_API_SOUND_H__ */

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("SPU OPEN SOUND I/F Ver 1.0");
MODULE_AUTHOR("Renesas Electronics");
